package com.ether;

import com.ether.annotation.ControllerMethod;
import com.ether.annotation.Mandatory;
import com.ether.annotation.ParamName;
import com.ether.annotation.UseJSON;
import com.ether.tapas.Tapas;
import net.sf.json.JSONObject;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.util.HashMap;
import java.util.Map;

/**
 * @author vmipsl
 * @date 02 march 2012
 */
public class Controller
        extends ControllerEther
{

    /** *********************************************************** **/
    /** *********************** VIEWS ***************************** **/
    /** *********************************************************** **/
    @ControllerMethod(view = VIEW_FORM_TAPAS)
    public Map<String, Object> viewForm()
            throws WebException
    {
        return new HashMap<String, Object>();
    }

    /** *********************************************************** **/
    /** *********************** CALLS ***************************** **/
    /** *********************************************************** **/
    @ControllerMethod(jsonResult = true)
    public JSONObject createUserRequest( @ParamName("jsonTapas") @Mandatory @UseJSON final Tapas javaTapas )
            throws WebException
    {
        if( null == javaTapas )
            throw new WebException( WebException.WebCode.ERROR_JSON_TAPAS_IS_NULL, "Serialization error : jsonTapas is null", WebException.getExceptionThrowable() );

        //appel a createxml
        getTapasService().createXMLRequest( javaTapas );

        final JSONObject result = new JSONObject();
        result.put( "result", "SUCCESS" );
        return result;
    }

    private static final Log LOGGER = LogFactory.getLog( Controller.class );

    private static final String VIEW_FORM_TAPAS = "project/formTapas";
}